/* Note.c generated by valac 0.16.1, the Vala compiler
 * generated from Note.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; intend-tabs-mode: t -*- */
/* PSNotes
 *
 * Copyright (C) Zach Burnham 2012 <thejambi@gmail.com>
 *
PSNotes is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * PSNotes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>


#define TYPE_NOTE (note_get_type ())
#define NOTE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTE, Note))
#define NOTE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTE, NoteClass))
#define IS_NOTE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTE))
#define IS_NOTE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTE))
#define NOTE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTE, NoteClass))

typedef struct _Note Note;
typedef struct _NoteClass NoteClass;
typedef struct _NotePrivate NotePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _note_saveAsyncData note_saveAsyncData;
typedef struct _note_saveFileContentsAsyncData note_saveFileContentsAsyncData;

struct _Note {
	GObject parent_instance;
	NotePrivate * priv;
};

struct _NoteClass {
	GObjectClass parent_class;
};

struct _NotePrivate {
	gchar* _title;
	gchar* filePath;
	GFile* noteFile;
};

struct _note_saveAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Note* self;
	gchar* text;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	GError * _inner_error_;
};

struct _note_saveFileContentsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Note* self;
	gchar* text;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError * _inner_error_;
};


static gpointer note_parent_class = NULL;

GType note_get_type (void) G_GNUC_CONST;
#define NOTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTE, NotePrivate))
enum  {
	NOTE_DUMMY_PROPERTY,
	NOTE_TITLE
};
Note* note_new (const gchar* title);
Note* note_construct (GType object_type, const gchar* title);
void note_setNoteInfo (Note* self, const gchar* title);
void zystem_debug (const gchar* s);
static void note_set_title (Note* self, const gchar* value);
gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd);
const gchar* user_data_get_notesDirPath (void);
const gchar* note_get_title (Note* self);
gchar* note_getContents (Note* self);
void note_rename (Note* self, const gchar* title, const gchar* text);
gboolean file_utility_isDuplicateNoteTitle (const gchar* title);
static void note_removeNoteFile (Note* self);
static void note_saveFileContents (Note* self, const gchar* text, GError** error);
static void note_saveAsync_data_free (gpointer _data);
void note_saveAsync (Note* self, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_);
void note_saveAsync_finish (Note* self, GAsyncResult* _res_, GError** error);
static gboolean note_saveAsync_co (note_saveAsyncData* _data_);
static void note_saveFileContentsAsync (Note* self, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void note_saveFileContentsAsync_finish (Note* self, GAsyncResult* _res_, GError** error);
static void note_saveAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void note_saveFileContentsAsync_data_free (gpointer _data);
static gboolean note_saveFileContentsAsync_co (note_saveFileContentsAsyncData* _data_);
static void note_saveFileContentsAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void note_save (Note* self, const gchar* text, GError** error);
void note_archive (Note* self);
void file_utility_moveFile (GFileInfo* file, const gchar* fromThisDir, const gchar* toThisPath);
gchar* user_data_getArchivedNotesDir (void);
static void note_finalize (GObject* obj);
static void _vala_note_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_note_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


Note* note_construct (GType object_type, const gchar* title) {
	Note * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (title != NULL, NULL);
	self = (Note*) g_object_new (object_type, NULL);
	_tmp0_ = title;
	note_setNoteInfo (self, _tmp0_);
	_tmp1_ = self->priv->filePath;
	_tmp2_ = g_strconcat ("Note path is: ", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	zystem_debug (_tmp3_);
	_g_free0 (_tmp3_);
	return self;
}


Note* note_new (const gchar* title) {
	return note_construct (TYPE_NOTE, title);
}


void note_setNoteInfo (Note* self, const gchar* title) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	GFile* _tmp8_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	_tmp0_ = title;
	note_set_title (self, _tmp0_);
	_tmp1_ = user_data_get_notesDirPath ();
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_title;
	_tmp4_ = g_strconcat (_tmp3_, ".txt", NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = file_utility_pathCombine (_tmp2_, _tmp5_);
	_g_free0 (self->priv->filePath);
	self->priv->filePath = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = self->priv->filePath;
	_tmp8_ = g_file_new_for_path (_tmp7_);
	_g_object_unref0 (self->priv->noteFile);
	self->priv->noteFile = _tmp8_;
}


gchar* note_getContents (Note* self) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gchar* contents = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		_tmp0_ = self->priv->filePath;
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp1_;
		if (_inner_error_ != NULL) {
			_g_free0 (contents);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch4_g_file_error;
			}
			_g_free0 (contents);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = contents;
		return result;
	}
	goto __finally4;
	__catch4_g_file_error:
	{
		GError* e = NULL;
		gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = g_strdup ("");
		result = _tmp2_;
		_g_error_free0 (e);
		return result;
	}
	__finally4:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


void note_rename (Note* self, const gchar* title, const gchar* text) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = title;
	_tmp1_ = file_utility_isDuplicateNoteTitle (_tmp0_);
	if (!_tmp1_) {
		const gchar* _tmp2_;
		note_removeNoteFile (self);
		_tmp2_ = title;
		note_setNoteInfo (self, _tmp2_);
	}
	_tmp3_ = text;
	note_saveFileContents (self, _tmp3_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void note_saveAsync_data_free (gpointer _data) {
	note_saveAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->text);
	_g_object_unref0 (_data_->self);
	g_slice_free (note_saveAsyncData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void note_saveAsync (Note* self, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	note_saveAsyncData* _data_;
	Note* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (note_saveAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, note_saveAsync);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, note_saveAsync_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = text;
	_tmp2_ = g_strdup (_tmp1_);
	_data_->text = _tmp2_;
	note_saveAsync_co (_data_);
}


void note_saveAsync_finish (Note* self, GAsyncResult* _res_, GError** error) {
	note_saveAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void note_saveAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	note_saveAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	note_saveAsync_co (_data_);
}


static gboolean note_saveAsync_co (note_saveAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->text;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = string_strip (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strcmp0 (_data_->_tmp2_, "") == 0;
	_g_free0 (_data_->_tmp2_);
	if (_data_->_tmp3_) {
		note_removeNoteFile (_data_->self);
	} else {
		_data_->_tmp4_ = _data_->text;
		_data_->_state_ = 1;
		note_saveFileContentsAsync (_data_->self, _data_->_tmp4_, note_saveAsync_ready, _data_);
		return FALSE;
		_state_1:
		note_saveFileContentsAsync_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
		if (_data_->_inner_error_ != NULL) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void note_saveFileContentsAsync_data_free (gpointer _data) {
	note_saveFileContentsAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->text);
	_g_object_unref0 (_data_->self);
	g_slice_free (note_saveFileContentsAsyncData, _data_);
}


static void note_saveFileContentsAsync (Note* self, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	note_saveFileContentsAsyncData* _data_;
	Note* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (note_saveFileContentsAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, note_saveFileContentsAsync);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, note_saveFileContentsAsync_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = text;
	_tmp2_ = g_strdup (_tmp1_);
	_data_->text = _tmp2_;
	note_saveFileContentsAsync_co (_data_);
}


static void note_saveFileContentsAsync_finish (Note* self, GAsyncResult* _res_, GError** error) {
	note_saveFileContentsAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static void note_saveFileContentsAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	note_saveFileContentsAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	note_saveFileContentsAsync_co (_data_);
}


static gboolean note_saveFileContentsAsync_co (note_saveFileContentsAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	zystem_debug ("ACTUALLY SAVING FILE");
	_data_->_tmp0_ = _data_->self->priv->noteFile;
	_data_->_tmp1_ = _data_->text;
	_data_->_tmp2_ = string_get_data (_data_->_tmp1_, &_data_->_tmp2__length1);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_tmp3__length1 = _data_->_tmp2__length1;
	_data_->_state_ = 1;
	g_file_replace_contents_async (_data_->_tmp0_, _data_->_tmp3_, (gsize) _data_->_tmp3__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, note_saveFileContentsAsync_ready, _data_);
	return FALSE;
	_state_1:
	g_file_replace_contents_finish (_data_->_tmp0_, _data_->_res_, NULL, &_data_->_inner_error_);
	if (_data_->_inner_error_ != NULL) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void note_save (Note* self, const gchar* text, GError** error) {
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = string_strip (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strcmp0 (_tmp2_, "") == 0;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		note_removeNoteFile (self);
	} else {
		const gchar* _tmp4_;
		_tmp4_ = text;
		note_saveFileContents (self, _tmp4_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static void note_saveFileContents (Note* self, const gchar* text, GError** error) {
	GFile* _tmp0_;
	const gchar* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	zystem_debug ("ACTUALLY SAVING FILE");
	_tmp0_ = self->priv->noteFile;
	_tmp1_ = text;
	_tmp2_ = string_get_data (_tmp1_, &_tmp2__length1);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	g_file_replace_contents (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void note_removeNoteFile (Note* self) {
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* file;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->filePath;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	file = _tmp1_;
	_tmp2_ = file;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (_tmp3_) {
		{
			GFile* _tmp4_;
			_tmp4_ = file;
			g_file_delete (_tmp4_, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch5_g_error;
			}
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			zystem_debug ("There was an error removing the entry file");
			_g_error_free0 (e);
		}
		__finally5:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (file);
}


/**
 * Move note file to the archive directory.
 */
void note_archive (Note* self) {
	GFile* _tmp0_;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* fileInfo;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->noteFile;
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
	fileInfo = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp2_ = user_data_get_notesDirPath ();
	_tmp3_ = _tmp2_;
	_tmp4_ = user_data_getArchivedNotesDir ();
	_tmp5_ = _tmp4_;
	file_utility_moveFile (fileInfo, _tmp3_, _tmp5_);
	_g_free0 (_tmp5_);
	_g_object_unref0 (fileInfo);
}


const gchar* note_get_title (Note* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}


static void note_set_title (Note* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_title);
	self->priv->_title = _tmp1_;
	g_object_notify ((GObject *) self, "title");
}


static void note_class_init (NoteClass * klass) {
	note_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_note_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_note_set_property;
	G_OBJECT_CLASS (klass)->finalize = note_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTE_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void note_instance_init (Note * self) {
	self->priv = NOTE_GET_PRIVATE (self);
}


static void note_finalize (GObject* obj) {
	Note * self;
	self = NOTE (obj);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->filePath);
	_g_object_unref0 (self->priv->noteFile);
	G_OBJECT_CLASS (note_parent_class)->finalize (obj);
}


GType note_get_type (void) {
	static volatile gsize note_type_id__volatile = 0;
	if (g_once_init_enter (&note_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) note_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Note), 0, (GInstanceInitFunc) note_instance_init, NULL };
		GType note_type_id;
		note_type_id = g_type_register_static (G_TYPE_OBJECT, "Note", &g_define_type_info, 0);
		g_once_init_leave (&note_type_id__volatile, note_type_id);
	}
	return note_type_id__volatile;
}


static void _vala_note_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Note * self;
	self = NOTE (object);
	switch (property_id) {
		case NOTE_TITLE:
		g_value_set_string (value, note_get_title (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_note_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Note * self;
	self = NOTE (object);
	switch (property_id) {
		case NOTE_TITLE:
		note_set_title (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



