/* NotesFilter.c generated by valac 0.16.1, the Vala compiler
 * generated from NotesFilter.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/* psnotes
 *
 * Copyright (C) 2012 Zach Burnham <thejambi@gmail.com>
 *
psnotes is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * psnotes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>


#define TYPE_LOAD_REQUEST_TYPE (load_request_type_get_type ())

#define TYPE_NOTES_FILTER (notes_filter_get_type ())
#define NOTES_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTES_FILTER, NotesFilter))
#define NOTES_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTES_FILTER, NotesFilterClass))
#define IS_NOTES_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTES_FILTER))
#define IS_NOTES_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTES_FILTER))
#define NOTES_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTES_FILTER, NotesFilterClass))

typedef struct _NotesFilter NotesFilter;
typedef struct _NotesFilterClass NotesFilterClass;
typedef struct _NotesFilterPrivate NotesFilterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NotesFilterFilterData NotesFilterFilterData;

typedef enum  {
	LOAD_REQUEST_TYPE_autoSaved,
	LOAD_REQUEST_TYPE_fileMonitorEvent,
	LOAD_REQUEST_TYPE_filterTextChanged,
	LOAD_REQUEST_TYPE_otherType
} LoadRequestType;

struct _NotesFilter {
	GObject parent_instance;
	NotesFilterPrivate * priv;
};

struct _NotesFilterClass {
	GObjectClass parent_class;
};

struct _NotesFilterPrivate {
	GtkListStore* listmodel;
	GtkTreeSelection* treeSelection;
	gint reloadCount;
	gboolean loadRequested;
	gboolean noLoad;
	gchar* filterText;
};

struct _NotesFilterFilterData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NotesFilter* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	GtkTreeSelection* _tmp12_;
	GtkListStore* _tmp13_;
	GtkListStore* _tmp14_;
	GtkTreeIter iter;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* notesDir;
	GFile* _tmp18_;
	GFileEnumerator* _tmp19_;
	GFileEnumerator* enumerator;
	GFileInfo* fileInfo;
	GFileEnumerator* _tmp20_;
	GFileInfo* _tmp21_;
	GFileInfo* _tmp22_;
	GFileInfo* _tmp23_;
	GFileInfo* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gboolean _tmp27_;
	GFileInfo* _tmp28_;
	gchar* _tmp29_;
	gchar* name;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	GtkListStore* _tmp38_;
	GtkTreeIter _tmp39_;
	GtkListStore* _tmp40_;
	GtkTreeIter _tmp41_;
	const gchar* _tmp42_;
	GError* e;
	FILE* _tmp43_;
	GError* _tmp44_;
	const gchar* _tmp45_;
	GtkTreeSelection* _tmp46_;
	GError * _inner_error_;
};


static gpointer notes_filter_parent_class = NULL;

GType load_request_type_get_type (void) G_GNUC_CONST;
GType notes_filter_get_type (void) G_GNUC_CONST;
#define NOTES_FILTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTES_FILTER, NotesFilterPrivate))
enum  {
	NOTES_FILTER_DUMMY_PROPERTY
};
NotesFilter* notes_filter_new (GtkListStore* listmodel, GtkTreeSelection* treeSelection);
NotesFilter* notes_filter_construct (GType object_type, GtkListStore* listmodel, GtkTreeSelection* treeSelection);
static void notes_filter_filter_data_free (gpointer _data);
void notes_filter_filter (NotesFilter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void notes_filter_filter_finish (NotesFilter* self, GAsyncResult* _res_);
static gboolean notes_filter_filter_co (NotesFilterFilterData* _data_);
void zystem_debug (const gchar* s);
const gchar* user_data_get_notesDirPath (void);
gchar* file_utility_getFileExtension (GFileInfo* file);
gchar* file_utility_getFileNameWithoutExtension (GFileInfo* file);
gboolean notes_filter_onTimerEvent (NotesFilter* self);
void notes_filter_setToLoad (NotesFilter* self, LoadRequestType requestType);
static gboolean _notes_filter_onTimerEvent_gsource_func (gpointer self);
void notes_filter_notifyAutoSave (NotesFilter* self);
void notes_filter_setFilterText (NotesFilter* self, const gchar* text);
static void notes_filter_finalize (GObject* obj);


GType load_request_type_get_type (void) {
	static volatile gsize load_request_type_type_id__volatile = 0;
	if (g_once_init_enter (&load_request_type_type_id__volatile)) {
		static const GEnumValue values[] = {{LOAD_REQUEST_TYPE_autoSaved, "LOAD_REQUEST_TYPE_autoSaved", "autosaved"}, {LOAD_REQUEST_TYPE_fileMonitorEvent, "LOAD_REQUEST_TYPE_fileMonitorEvent", "filemonitorevent"}, {LOAD_REQUEST_TYPE_filterTextChanged, "LOAD_REQUEST_TYPE_filterTextChanged", "filtertextchanged"}, {LOAD_REQUEST_TYPE_otherType, "LOAD_REQUEST_TYPE_otherType", "othertype"}, {0, NULL, NULL}};
		GType load_request_type_type_id;
		load_request_type_type_id = g_enum_register_static ("LoadRequestType", values);
		g_once_init_leave (&load_request_type_type_id__volatile, load_request_type_type_id);
	}
	return load_request_type_type_id__volatile;
}


NotesFilter* notes_filter_construct (GType object_type, GtkListStore* listmodel, GtkTreeSelection* treeSelection) {
	NotesFilter * self = NULL;
	GtkListStore* _tmp0_;
	GtkTreeSelection* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (listmodel != NULL, NULL);
	g_return_val_if_fail (treeSelection != NULL, NULL);
	self = (NotesFilter*) g_object_new (object_type, NULL);
	_tmp0_ = listmodel;
	self->priv->listmodel = _tmp0_;
	_tmp1_ = treeSelection;
	self->priv->treeSelection = _tmp1_;
	self->priv->loadRequested = FALSE;
	self->priv->reloadCount = 0;
	self->priv->noLoad = FALSE;
	_tmp2_ = g_strdup ("");
	_g_free0 (self->priv->filterText);
	self->priv->filterText = _tmp2_;
	return self;
}


NotesFilter* notes_filter_new (GtkListStore* listmodel, GtkTreeSelection* treeSelection) {
	return notes_filter_construct (TYPE_NOTES_FILTER, listmodel, treeSelection);
}


static void notes_filter_filter_data_free (gpointer _data) {
	NotesFilterFilterData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (NotesFilterFilterData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void notes_filter_filter (NotesFilter* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NotesFilterFilterData* _data_;
	NotesFilter* _tmp0_;
	_data_ = g_slice_new0 (NotesFilterFilterData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, notes_filter_filter);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, notes_filter_filter_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	notes_filter_filter_co (_data_);
}


void notes_filter_filter_finish (NotesFilter* self, GAsyncResult* _res_) {
	NotesFilterFilterData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gboolean notes_filter_filter_co (NotesFilterFilterData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->filterText;
	_data_->_tmp1_ = g_strconcat ("Filter Text:", _data_->_tmp0_, NULL);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strconcat (_data_->_tmp2_, "|", NULL);
	_data_->_tmp4_ = _data_->_tmp3_;
	zystem_debug (_data_->_tmp4_);
	_g_free0 (_data_->_tmp4_);
	_g_free0 (_data_->_tmp2_);
	_data_->_tmp5_ = _data_->self->priv->reloadCount;
	_data_->self->priv->reloadCount = _data_->_tmp5_ + 1;
	_data_->_tmp6_ = _data_->self->priv->reloadCount;
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = g_strdup_printf ("%i", _data_->_tmp6_);
	_data_->_tmp8_ = _data_->_tmp7_;
	_data_->_tmp9_ = g_strconcat ("********************   Reload count is: ", _data_->_tmp8_, NULL);
	_data_->_tmp10_ = _data_->_tmp9_;
	zystem_debug (_data_->_tmp10_);
	_g_free0 (_data_->_tmp10_);
	_g_free0 (_data_->_tmp8_);
	_data_->_tmp11_ = _data_->self->priv->reloadCount;
	if (_data_->_tmp11_ < 0) {
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp12_ = _data_->self->priv->treeSelection;
	gtk_tree_selection_set_mode (_data_->_tmp12_, GTK_SELECTION_NONE);
	{
		_data_->_tmp13_ = _data_->self->priv->listmodel;
		gtk_list_store_clear (_data_->_tmp13_);
		_data_->_tmp14_ = _data_->self->priv->listmodel;
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _data_->_tmp14_, 0, GTK_SORT_ASCENDING);
		_data_->_tmp15_ = user_data_get_notesDirPath ();
		_data_->_tmp16_ = _data_->_tmp15_;
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = g_file_new_for_path (_data_->_tmp16_);
		_data_->notesDir = _data_->_tmp17_;
		_data_->_tmp18_ = _data_->notesDir;
		_data_->_tmp19_ = NULL;
		_data_->_tmp19_ = g_file_enumerate_children (_data_->_tmp18_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_data_->_inner_error_);
		_data_->enumerator = _data_->_tmp19_;
		if (_data_->_inner_error_ != NULL) {
			_g_object_unref0 (_data_->notesDir);
			goto __catch6_g_error;
		}
		while (TRUE) {
			_data_->_tmp20_ = _data_->enumerator;
			_data_->_tmp21_ = NULL;
			_data_->_tmp21_ = g_file_enumerator_next_file (_data_->_tmp20_, NULL, &_data_->_inner_error_);
			_data_->_tmp22_ = _data_->_tmp21_;
			if (_data_->_inner_error_ != NULL) {
				_g_object_unref0 (_data_->fileInfo);
				_g_object_unref0 (_data_->enumerator);
				_g_object_unref0 (_data_->notesDir);
				goto __catch6_g_error;
			}
			_g_object_unref0 (_data_->fileInfo);
			_data_->fileInfo = _data_->_tmp22_;
			_data_->_tmp23_ = _data_->fileInfo;
			if (!(_data_->_tmp23_ != NULL)) {
				break;
			}
			_data_->_tmp24_ = _data_->fileInfo;
			_data_->_tmp25_ = NULL;
			_data_->_tmp25_ = file_utility_getFileExtension (_data_->_tmp24_);
			_data_->_tmp26_ = _data_->_tmp25_;
			_data_->_tmp27_ = g_strcmp0 (_data_->_tmp26_, ".txt") == 0;
			_g_free0 (_data_->_tmp26_);
			if (_data_->_tmp27_) {
				_data_->_tmp28_ = _data_->fileInfo;
				_data_->_tmp29_ = NULL;
				_data_->_tmp29_ = file_utility_getFileNameWithoutExtension (_data_->_tmp28_);
				_data_->name = _data_->_tmp29_;
				_data_->_tmp30_ = _data_->name;
				_data_->_tmp31_ = NULL;
				_data_->_tmp31_ = g_utf8_strdown (_data_->_tmp30_, (gssize) (-1));
				_data_->_tmp32_ = _data_->_tmp31_;
				_data_->_tmp33_ = _data_->self->priv->filterText;
				_data_->_tmp34_ = NULL;
				_data_->_tmp34_ = g_utf8_strdown (_data_->_tmp33_, (gssize) (-1));
				_data_->_tmp35_ = _data_->_tmp34_;
				_data_->_tmp36_ = FALSE;
				_data_->_tmp36_ = string_contains (_data_->_tmp32_, _data_->_tmp35_);
				_data_->_tmp37_ = _data_->_tmp36_;
				_g_free0 (_data_->_tmp35_);
				_g_free0 (_data_->_tmp32_);
				if (_data_->_tmp37_) {
					_data_->_tmp38_ = _data_->self->priv->listmodel;
					memset (&_data_->_tmp39_, 0, sizeof (GtkTreeIter));
					gtk_list_store_append (_data_->_tmp38_, &_data_->_tmp39_);
					_data_->iter = _data_->_tmp39_;
					_data_->_tmp40_ = _data_->self->priv->listmodel;
					_data_->_tmp41_ = _data_->iter;
					_data_->_tmp42_ = _data_->name;
					gtk_list_store_set (_data_->_tmp40_, &_data_->_tmp41_, 0, _data_->_tmp42_, -1);
				}
				_g_free0 (_data_->name);
			}
		}
		_g_object_unref0 (_data_->fileInfo);
		_g_object_unref0 (_data_->enumerator);
		_g_object_unref0 (_data_->notesDir);
	}
	goto __finally6;
	__catch6_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp43_ = stderr;
		_data_->_tmp44_ = _data_->e;
		_data_->_tmp45_ = _data_->_tmp44_->message;
		fprintf (_data_->_tmp43_, "Error loading notes list: %s\n", _data_->_tmp45_);
		_g_error_free0 (_data_->e);
	}
	__finally6:
	if (_data_->_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		return FALSE;
	}
	_data_->_tmp46_ = _data_->self->priv->treeSelection;
	gtk_tree_selection_set_mode (_data_->_tmp46_, GTK_SELECTION_SINGLE);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


gboolean notes_filter_onTimerEvent (NotesFilter* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->loadRequested = FALSE;
	_tmp0_ = self->priv->noLoad;
	if (_tmp0_) {
		zystem_debug ("------------------------------> NoLoad! <------------------------");
		self->priv->noLoad = FALSE;
		result = FALSE;
		return result;
	}
	zystem_debug ("Timer event. Calling filter.");
	notes_filter_filter (self, NULL, NULL);
	result = FALSE;
	return result;
}


static gboolean _notes_filter_onTimerEvent_gsource_func (gpointer self) {
	gboolean result;
	result = notes_filter_onTimerEvent (self);
	return result;
}


void notes_filter_setToLoad (NotesFilter* self, LoadRequestType requestType) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->loadRequested;
	if (!_tmp1_) {
		LoadRequestType _tmp2_;
		_tmp2_ = requestType;
		_tmp0_ = _tmp2_ != LOAD_REQUEST_TYPE_autoSaved;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		guint _tmp4_ = 0U;
		guint timerId;
		_tmp4_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _notes_filter_onTimerEvent_gsource_func, g_object_ref (self), g_object_unref);
		timerId = _tmp4_;
		zystem_debug ("Set timer!");
	} else {
		zystem_debug ("No Timer Set! Take THAT!");
	}
	self->priv->loadRequested = TRUE;
}


void notes_filter_notifyAutoSave (NotesFilter* self) {
	g_return_if_fail (self != NULL);
	self->priv->noLoad = TRUE;
}


void notes_filter_setFilterText (NotesFilter* self, const gchar* text) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->filterText);
	self->priv->filterText = _tmp1_;
}


static void notes_filter_class_init (NotesFilterClass * klass) {
	notes_filter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotesFilterPrivate));
	G_OBJECT_CLASS (klass)->finalize = notes_filter_finalize;
}


static void notes_filter_instance_init (NotesFilter * self) {
	self->priv = NOTES_FILTER_GET_PRIVATE (self);
}


static void notes_filter_finalize (GObject* obj) {
	NotesFilter * self;
	self = NOTES_FILTER (obj);
	_g_free0 (self->priv->filterText);
	G_OBJECT_CLASS (notes_filter_parent_class)->finalize (obj);
}


GType notes_filter_get_type (void) {
	static volatile gsize notes_filter_type_id__volatile = 0;
	if (g_once_init_enter (&notes_filter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotesFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notes_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotesFilter), 0, (GInstanceInitFunc) notes_filter_instance_init, NULL };
		GType notes_filter_type_id;
		notes_filter_type_id = g_type_register_static (G_TYPE_OBJECT, "NotesFilter", &g_define_type_info, 0);
		g_once_init_leave (&notes_filter_type_id__volatile, notes_filter_type_id);
	}
	return notes_filter_type_id__volatile;
}



