/* NotesMonitor.c generated by valac 0.16.1, the Vala compiler
 * generated from NotesMonitor.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/* psnotes
 *
 * Copyright (C) 2012 Zach Burnham <thejambi@gmail.com>
 *
psnotes is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * psnotes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_NOTES_MONITOR (notes_monitor_get_type ())
#define NOTES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTES_MONITOR, NotesMonitor))
#define NOTES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTES_MONITOR, NotesMonitorClass))
#define IS_NOTES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTES_MONITOR))
#define IS_NOTES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTES_MONITOR))
#define NOTES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTES_MONITOR, NotesMonitorClass))

typedef struct _NotesMonitor NotesMonitor;
typedef struct _NotesMonitorClass NotesMonitorClass;
typedef struct _NotesMonitorPrivate NotesMonitorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NotesMonitor {
	GObject parent_instance;
	NotesMonitorPrivate * priv;
};

struct _NotesMonitorClass {
	GObjectClass parent_class;
};

struct _NotesMonitorPrivate {
	GFile* monitoredFile;
};


static gpointer notes_monitor_parent_class = NULL;

GType notes_monitor_get_type (void) G_GNUC_CONST;
#define NOTES_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTES_MONITOR, NotesMonitorPrivate))
enum  {
	NOTES_MONITOR_DUMMY_PROPERTY
};
NotesMonitor* notes_monitor_new (const gchar* filePath);
NotesMonitor* notes_monitor_construct (GType object_type, const gchar* filePath);
void zystem_debug (const gchar* s);
GFileMonitor* notes_monitor_getFileMonitor (NotesMonitor* self);
static void notes_monitor_finalize (GObject* obj);


NotesMonitor* notes_monitor_construct (GType object_type, const gchar* filePath) {
	NotesMonitor * self = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (filePath != NULL, NULL);
	self = (NotesMonitor*) g_object_new (object_type, NULL);
	_tmp0_ = filePath;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	_g_object_unref0 (self->priv->monitoredFile);
	self->priv->monitoredFile = _tmp1_;
	_tmp2_ = filePath;
	_tmp3_ = g_strconcat ("Created the Monitor for ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	zystem_debug (_tmp4_);
	_g_free0 (_tmp4_);
	return self;
}


NotesMonitor* notes_monitor_new (const gchar* filePath) {
	return notes_monitor_construct (TYPE_NOTES_MONITOR, filePath);
}


GFileMonitor* notes_monitor_getFileMonitor (NotesMonitor* self) {
	GFileMonitor* result = NULL;
	GFile* _tmp0_;
	GFileMonitor* _tmp1_ = NULL;
	GFileMonitor* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->monitoredFile;
	_tmp1_ = g_file_monitor_directory (_tmp0_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp2_;
	return result;
}


static void notes_monitor_class_init (NotesMonitorClass * klass) {
	notes_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotesMonitorPrivate));
	G_OBJECT_CLASS (klass)->finalize = notes_monitor_finalize;
}


static void notes_monitor_instance_init (NotesMonitor * self) {
	self->priv = NOTES_MONITOR_GET_PRIVATE (self);
}


static void notes_monitor_finalize (GObject* obj) {
	NotesMonitor * self;
	self = NOTES_MONITOR (obj);
	_g_object_unref0 (self->priv->monitoredFile);
	G_OBJECT_CLASS (notes_monitor_parent_class)->finalize (obj);
}


GType notes_monitor_get_type (void) {
	static volatile gsize notes_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&notes_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotesMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notes_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotesMonitor), 0, (GInstanceInitFunc) notes_monitor_instance_init, NULL };
		GType notes_monitor_type_id;
		notes_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "NotesMonitor", &g_define_type_info, 0);
		g_once_init_leave (&notes_monitor_type_id__volatile, notes_monitor_type_id);
	}
	return notes_monitor_type_id__volatile;
}



