/* UserData.c generated by valac 0.16.1, the Vala compiler
 * generated from UserData.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; intend-tabs-mode: t -*- */
/* PSNotes
 *
 * Copyright (C) Zach Burnham 2012 <thejambi@gmail.com>
 *
PSNotes is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * PSNotes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>


#define TYPE_USER_DATA (user_data_get_type ())
#define USER_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_DATA, UserData))
#define USER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_DATA, UserDataClass))
#define IS_USER_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_DATA))
#define IS_USER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_DATA))
#define USER_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_DATA, UserDataClass))

typedef struct _UserData UserData;
typedef struct _UserDataClass UserDataClass;
typedef struct _UserDataPrivate UserDataPrivate;

#define TYPE_USER_SETTINGS_MANAGER (user_settings_manager_get_type ())
#define USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManager))
#define USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))
#define IS_USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_SETTINGS_MANAGER))
#define IS_USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_SETTINGS_MANAGER))
#define USER_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))

typedef struct _UserSettingsManager UserSettingsManager;
typedef struct _UserSettingsManagerClass UserSettingsManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UserData {
	GObject parent_instance;
	UserDataPrivate * priv;
};

struct _UserDataClass {
	GObjectClass parent_class;
};


static gpointer user_data_parent_class = NULL;
static gchar* user_data__defaultNotesDirName;
static gchar* user_data__defaultNotesDirName = NULL;
static gchar* user_data__notesDirPath;
static gchar* user_data__notesDirPath = NULL;
static gchar* user_data__homeDirPath;
static gchar* user_data__homeDirPath = NULL;
static gboolean user_data__seldomSave;
static gboolean user_data__seldomSave = TRUE;
static gint user_data__windowWidth;
static gint user_data__windowWidth = 530;
static gint user_data__windowHeight;
static gint user_data__windowHeight = 400;
static gint user_data__panePosition;
static gint user_data__panePosition = 166;
static UserSettingsManager* user_data_settings;
static UserSettingsManager* user_data_settings = NULL;

GType user_data_get_type (void) G_GNUC_CONST;
enum  {
	USER_DATA_DUMMY_PROPERTY
};
GType user_settings_manager_get_type (void) G_GNUC_CONST;
void user_data_initializeUserData (void);
const gchar* user_data_get_homeDirPath (void);
static void user_data_set_homeDirPath (const gchar* value);
const gchar* user_data_get_defaultNotesDirName (void);
static void user_data_set_defaultNotesDirName (const gchar* value);
UserSettingsManager* user_settings_manager_new (void);
UserSettingsManager* user_settings_manager_construct (GType object_type);
void zystem_debug (const gchar* s);
gint user_data_get_windowWidth (void);
void file_utility_createFolder (const gchar* dirPath);
const gchar* user_data_get_notesDirPath (void);
void user_data_setNotesDir (const gchar* path);
void user_data_set_notesDirPath (const gchar* value);
void user_settings_manager_setNotesDir (UserSettingsManager* self, const gchar* path);
gchar* user_data_getDefaultNotesDir (void);
gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd);
gchar* user_data_getNewEntrySectionText (void);
void user_data_saveWindowSize (gint width, gint height);
void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val);
#define USER_SETTINGS_MANAGER_windowWidthKey "width"
#define USER_SETTINGS_MANAGER_windowHeightKey "height"
void user_data_savePanePosition (gint position);
#define USER_SETTINGS_MANAGER_panePositionKey "panePosition"
gchar* user_data_getArchivedNotesDir (void);
void user_data_rememberCurrentNotebook (void);
void user_settings_manager_addNotebook (UserSettingsManager* self, const gchar* name, const gchar* path);
void user_data_forgetCurrentNotebook (void);
void user_settings_manager_removeNotebook (UserSettingsManager* self, const gchar* name);
GeeArrayList* user_data_getNotebookList (void);
GeeArrayList* user_settings_manager_getNotebookList (UserSettingsManager* self);
UserData* user_data_new (void);
UserData* user_data_construct (GType object_type);
gboolean user_data_get_seldomSave (void);
void user_data_set_seldomSave (gboolean value);
void user_data_set_windowWidth (gint value);
gint user_data_get_windowHeight (void);
void user_data_set_windowHeight (gint value);
gint user_data_get_panePosition (void);
void user_data_set_panePosition (gint value);
static void user_data_finalize (GObject* obj);
static void _vala_user_data_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_user_data_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void user_data_initializeUserData (void) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	UserSettingsManager* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_get_home_dir ();
	user_data_set_homeDirPath (_tmp2_);
	_tmp3_ = user_data_get_defaultNotesDirName ();
	_tmp4_ = _tmp3_;
	user_data_set_defaultNotesDirName ("PS Notes");
	_tmp5_ = user_settings_manager_new ();
	_g_object_unref0 (user_data_settings);
	user_data_settings = _tmp5_;
	_tmp6_ = user_data_get_windowWidth ();
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("Width is: ", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	zystem_debug (_tmp11_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_tmp12_ = user_data_get_notesDirPath ();
	_tmp13_ = _tmp12_;
	file_utility_createFolder (_tmp13_);
}


void user_data_setNotesDir (const gchar* path) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	UserSettingsManager* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (path != NULL);
	zystem_debug ("Setting Notes directory");
	_tmp0_ = user_data_get_notesDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = path;
	user_data_set_notesDirPath (_tmp2_);
	_tmp3_ = user_data_settings;
	_tmp4_ = path;
	user_settings_manager_setNotesDir (_tmp3_, _tmp4_);
}


gchar* user_data_getDefaultNotesDir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = user_data_get_defaultNotesDirName ();
	_tmp3_ = _tmp2_;
	_tmp4_ = file_utility_pathCombine (_tmp1_, _tmp3_);
	result = _tmp4_;
	return result;
}


gchar* user_data_getNewEntrySectionText (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* newSectionText;
	_tmp0_ = g_strdup ("\n\n-----\n\n");
	newSectionText = _tmp0_;
	result = newSectionText;
	return result;
}


void user_data_saveWindowSize (gint width, gint height) {
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	UserSettingsManager* _tmp10_;
	gint _tmp11_;
	UserSettingsManager* _tmp12_;
	gint _tmp13_;
	_tmp0_ = width;
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, " and the height: ", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = height;
	_tmp6_ = g_strdup_printf ("%i", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	zystem_debug (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp10_ = user_data_settings;
	_tmp11_ = width;
	user_settings_manager_setInt (_tmp10_, USER_SETTINGS_MANAGER_windowWidthKey, _tmp11_);
	_tmp12_ = user_data_settings;
	_tmp13_ = height;
	user_settings_manager_setInt (_tmp12_, USER_SETTINGS_MANAGER_windowHeightKey, _tmp13_);
}


void user_data_savePanePosition (gint position) {
	UserSettingsManager* _tmp0_;
	gint _tmp1_;
	_tmp0_ = user_data_settings;
	_tmp1_ = position;
	user_settings_manager_setInt (_tmp0_, USER_SETTINGS_MANAGER_panePositionKey, _tmp1_);
}


gchar* user_data_getArchivedNotesDir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* path;
	const gchar* _tmp3_;
	GFile* _tmp4_ = NULL;
	GFile* file;
	GFile* _tmp5_;
	gboolean _tmp6_ = FALSE;
	_tmp0_ = user_data_get_notesDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = file_utility_pathCombine (_tmp1_, "Archive");
	path = _tmp2_;
	_tmp3_ = path;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	file = _tmp4_;
	_tmp5_ = file;
	_tmp6_ = g_file_query_exists (_tmp5_, NULL);
	if (!_tmp6_) {
		const gchar* _tmp7_;
		_tmp7_ = path;
		file_utility_createFolder (_tmp7_);
	}
	result = path;
	_g_object_unref0 (file);
	return result;
}


void user_data_rememberCurrentNotebook (void) {
	UserSettingsManager* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_data_get_notesDirPath ();
	_tmp2_ = _tmp1_;
	_tmp3_ = user_data_get_notesDirPath ();
	_tmp4_ = _tmp3_;
	user_settings_manager_addNotebook (_tmp0_, _tmp2_, _tmp4_);
}


void user_data_forgetCurrentNotebook (void) {
	UserSettingsManager* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_data_get_notesDirPath ();
	_tmp2_ = _tmp1_;
	user_settings_manager_removeNotebook (_tmp0_, _tmp2_);
}


GeeArrayList* user_data_getNotebookList (void) {
	GeeArrayList* result = NULL;
	UserSettingsManager* _tmp0_;
	GeeArrayList* _tmp1_ = NULL;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_settings_manager_getNotebookList (_tmp0_);
	result = _tmp1_;
	return result;
}


UserData* user_data_construct (GType object_type) {
	UserData * self = NULL;
	self = (UserData*) g_object_new (object_type, NULL);
	return self;
}


UserData* user_data_new (void) {
	return user_data_construct (TYPE_USER_DATA);
}


const gchar* user_data_get_defaultNotesDirName (void) {
	const gchar* result;
	const gchar* _tmp0_;
	_tmp0_ = user_data__defaultNotesDirName;
	result = _tmp0_;
	return result;
}


static void user_data_set_defaultNotesDirName (const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__defaultNotesDirName);
	user_data__defaultNotesDirName = _tmp1_;
}


const gchar* user_data_get_notesDirPath (void) {
	const gchar* result;
	const gchar* _tmp0_;
	_tmp0_ = user_data__notesDirPath;
	result = _tmp0_;
	return result;
}


void user_data_set_notesDirPath (const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__notesDirPath);
	user_data__notesDirPath = _tmp1_;
}


const gchar* user_data_get_homeDirPath (void) {
	const gchar* result;
	const gchar* _tmp0_;
	_tmp0_ = user_data__homeDirPath;
	result = _tmp0_;
	return result;
}


static void user_data_set_homeDirPath (const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__homeDirPath);
	user_data__homeDirPath = _tmp1_;
}


gboolean user_data_get_seldomSave (void) {
	gboolean result;
	gboolean _tmp0_;
	_tmp0_ = user_data__seldomSave;
	result = _tmp0_;
	return result;
}


void user_data_set_seldomSave (gboolean value) {
	gboolean _tmp0_;
	_tmp0_ = value;
	user_data__seldomSave = _tmp0_;
}


gint user_data_get_windowWidth (void) {
	gint result;
	gint _tmp0_;
	_tmp0_ = user_data__windowWidth;
	result = _tmp0_;
	return result;
}


void user_data_set_windowWidth (gint value) {
	gint _tmp0_;
	_tmp0_ = value;
	user_data__windowWidth = _tmp0_;
}


gint user_data_get_windowHeight (void) {
	gint result;
	gint _tmp0_;
	_tmp0_ = user_data__windowHeight;
	result = _tmp0_;
	return result;
}


void user_data_set_windowHeight (gint value) {
	gint _tmp0_;
	_tmp0_ = value;
	user_data__windowHeight = _tmp0_;
}


gint user_data_get_panePosition (void) {
	gint result;
	gint _tmp0_;
	_tmp0_ = user_data__panePosition;
	result = _tmp0_;
	return result;
}


void user_data_set_panePosition (gint value) {
	gint _tmp0_;
	_tmp0_ = value;
	user_data__panePosition = _tmp0_;
}


static void user_data_class_init (UserDataClass * klass) {
	user_data_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_user_data_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_user_data_set_property;
	G_OBJECT_CLASS (klass)->finalize = user_data_finalize;
}


static void user_data_instance_init (UserData * self) {
}


static void user_data_finalize (GObject* obj) {
	UserData * self;
	self = USER_DATA (obj);
	G_OBJECT_CLASS (user_data_parent_class)->finalize (obj);
}


GType user_data_get_type (void) {
	static volatile gsize user_data_type_id__volatile = 0;
	if (g_once_init_enter (&user_data_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserData), 0, (GInstanceInitFunc) user_data_instance_init, NULL };
		GType user_data_type_id;
		user_data_type_id = g_type_register_static (G_TYPE_OBJECT, "UserData", &g_define_type_info, 0);
		g_once_init_leave (&user_data_type_id__volatile, user_data_type_id);
	}
	return user_data_type_id__volatile;
}


static void _vala_user_data_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UserData * self;
	self = USER_DATA (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_user_data_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserData * self;
	self = USER_DATA (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



