/* UserSettingsManager.c generated by valac 0.16.1, the Vala compiler
 * generated from UserSettingsManager.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; intend-tabs-mode: t -*- */
/* PSNotes
 *
 * Copyright (C) Zach Burnham 2012 <thejambi@gmail.com>
 *
PSNotes is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * PSNotes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gee.h>


#define TYPE_USER_SETTINGS_MANAGER (user_settings_manager_get_type ())
#define USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManager))
#define USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))
#define IS_USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_SETTINGS_MANAGER))
#define IS_USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_SETTINGS_MANAGER))
#define USER_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))

typedef struct _UserSettingsManager UserSettingsManager;
typedef struct _UserSettingsManagerClass UserSettingsManagerClass;
typedef struct _UserSettingsManagerPrivate UserSettingsManagerPrivate;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _UserSettingsManager {
	GObject parent_instance;
	UserSettingsManagerPrivate * priv;
};

struct _UserSettingsManagerClass {
	GObjectClass parent_class;
};

struct _UserSettingsManagerPrivate {
	GKeyFile* keyFile;
	gchar* psNotesConfPath;
};


static gpointer user_settings_manager_parent_class = NULL;

GType user_settings_manager_get_type (void) G_GNUC_CONST;
#define USER_SETTINGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerPrivate))
enum  {
	USER_SETTINGS_MANAGER_DUMMY_PROPERTY
};
#define USER_SETTINGS_MANAGER_notesDirKey "notesDirectory"
#define USER_SETTINGS_MANAGER_notesDirGroup "PSNotes"
#define USER_SETTINGS_MANAGER_notebooksGroup "Notebooks"
#define USER_SETTINGS_MANAGER_windowWidthKey "width"
#define USER_SETTINGS_MANAGER_windowHeightKey "height"
#define USER_SETTINGS_MANAGER_panePositionKey "panePosition"
UserSettingsManager* user_settings_manager_new (void);
UserSettingsManager* user_settings_manager_construct (GType object_type);
const gchar* user_data_get_homeDirPath (void);
void file_utility_createFolder (const gchar* dirPath);
static gboolean user_settings_manager_processKeyFile (UserSettingsManager* self);
static void user_settings_manager_writeKeyFile (UserSettingsManager* self);
const gchar* user_data_get_notesDirPath (void);
void user_data_set_notesDirPath (const gchar* value);
void zystem_debug (const gchar* s);
gchar* user_data_getDefaultNotesDir (void);
gint user_data_get_windowWidth (void);
void user_data_set_windowWidth (gint value);
gint user_data_get_windowHeight (void);
void user_data_set_windowHeight (gint value);
gint user_data_get_panePosition (void);
void user_data_set_panePosition (gint value);
void user_settings_manager_setNotesDir (UserSettingsManager* self, const gchar* path);
void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val);
void user_settings_manager_addNotebook (UserSettingsManager* self, const gchar* name, const gchar* path);
void user_settings_manager_removeNotebook (UserSettingsManager* self, const gchar* name);
GeeArrayList* user_settings_manager_getNotebookList (UserSettingsManager* self);
static void user_settings_manager_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


UserSettingsManager* user_settings_manager_construct (GType object_type) {
	UserSettingsManager * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* settingsDirPath;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_ = NULL;
	GFile* settingsFile;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GKeyFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (UserSettingsManager*) g_object_new (object_type, NULL);
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "/.config/psnotes", NULL);
	settingsDirPath = _tmp2_;
	_tmp3_ = settingsDirPath;
	file_utility_createFolder (_tmp3_);
	_tmp4_ = settingsDirPath;
	_tmp5_ = g_strconcat (_tmp4_, "/psnotes.conf", NULL);
	_g_free0 (self->priv->psNotesConfPath);
	self->priv->psNotesConfPath = _tmp5_;
	_tmp6_ = self->priv->psNotesConfPath;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	settingsFile = _tmp7_;
	_tmp8_ = settingsFile;
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
	if (!_tmp9_) {
		{
			GFile* _tmp10_;
			GFileOutputStream* _tmp11_ = NULL;
			GFileOutputStream* _tmp12_;
			_tmp10_ = settingsFile;
			_tmp11_ = g_file_create (_tmp10_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
			_tmp12_ = _tmp11_;
			_g_object_unref0 (_tmp12_);
			if (_inner_error_ != NULL) {
				goto __catch7_g_error;
			}
		}
		goto __finally7;
		__catch7_g_error:
		{
			GError* e = NULL;
			FILE* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp13_ = stderr;
			_tmp14_ = e;
			_tmp15_ = _tmp14_->message;
			fprintf (_tmp13_, "Error creating settings file: %s\n", _tmp15_);
			_g_error_free0 (e);
		}
		__finally7:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (settingsFile);
			_g_free0 (settingsDirPath);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp16_ = g_key_file_new ();
	_g_key_file_free0 (self->priv->keyFile);
	self->priv->keyFile = _tmp16_;
	{
		GKeyFile* _tmp17_;
		const gchar* _tmp18_;
		_tmp17_ = self->priv->keyFile;
		_tmp18_ = self->priv->psNotesConfPath;
		g_key_file_load_from_file (_tmp17_, _tmp18_, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		FILE* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = stderr;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		fprintf (_tmp19_, "Error in UserSettingsManager(): %s\n", _tmp21_);
		_g_error_free0 (e);
	}
	__finally8:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (settingsFile);
		_g_free0 (settingsDirPath);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp22_ = user_settings_manager_processKeyFile (self);
	if (_tmp22_) {
		user_settings_manager_writeKeyFile (self);
	}
	_g_object_unref0 (settingsFile);
	_g_free0 (settingsDirPath);
	return self;
}


UserSettingsManager* user_settings_manager_new (void) {
	return user_settings_manager_construct (TYPE_USER_SETTINGS_MANAGER);
}


/**
 * Process the key file. Return true if keyFile needs to be written.
 */
static gboolean user_settings_manager_processKeyFile (UserSettingsManager* self) {
	gboolean result = FALSE;
	GKeyFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* originalKeyFileData;
	const gchar* _tmp27_;
	GKeyFile* _tmp28_;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_;
	gboolean _tmp31_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = g_key_file_to_data (_tmp0_, NULL, NULL);
	originalKeyFileData = _tmp1_;
	{
		GKeyFile* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp2_ = self->priv->keyFile;
		_tmp3_ = g_key_file_get_string (_tmp2_, USER_SETTINGS_MANAGER_notesDirGroup, USER_SETTINGS_MANAGER_notesDirKey, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch9_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp5_ = user_data_get_notesDirPath ();
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp4_;
		user_data_set_notesDirPath (_tmp7_);
		_g_free0 (_tmp7_);
		zystem_debug ("Got notes dir path");
	}
	goto __finally9;
	__catch9_g_key_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = user_data_get_notesDirPath ();
		_tmp9_ = _tmp8_;
		_tmp10_ = user_data_getDefaultNotesDir ();
		_tmp11_ = _tmp10_;
		user_data_set_notesDirPath (_tmp11_);
		_g_free0 (_tmp11_);
		zystem_debug ("Gotta use the default...");
		_g_error_free0 (e);
	}
	__finally9:
	if (_inner_error_ != NULL) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		GKeyFile* _tmp12_;
		gint _tmp13_ = 0;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		GKeyFile* _tmp17_;
		gint _tmp18_ = 0;
		gint _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		GKeyFile* _tmp22_;
		gint _tmp23_ = 0;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		_tmp12_ = self->priv->keyFile;
		_tmp13_ = g_key_file_get_integer (_tmp12_, USER_SETTINGS_MANAGER_notesDirGroup, USER_SETTINGS_MANAGER_windowWidthKey, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch10_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp15_ = user_data_get_windowWidth ();
		_tmp16_ = _tmp15_;
		user_data_set_windowWidth (_tmp14_);
		_tmp17_ = self->priv->keyFile;
		_tmp18_ = g_key_file_get_integer (_tmp17_, USER_SETTINGS_MANAGER_notesDirGroup, USER_SETTINGS_MANAGER_windowHeightKey, &_inner_error_);
		_tmp19_ = _tmp18_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch10_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp20_ = user_data_get_windowHeight ();
		_tmp21_ = _tmp20_;
		user_data_set_windowHeight (_tmp19_);
		_tmp22_ = self->priv->keyFile;
		_tmp23_ = g_key_file_get_integer (_tmp22_, USER_SETTINGS_MANAGER_notesDirGroup, USER_SETTINGS_MANAGER_panePositionKey, &_inner_error_);
		_tmp24_ = _tmp23_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch10_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp25_ = user_data_get_panePosition ();
		_tmp26_ = _tmp25_;
		user_data_set_panePosition (_tmp24_);
	}
	goto __finally10;
	__catch10_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		zystem_debug ("Error loading window size; using default.");
		_g_error_free0 (e);
	}
	__finally10:
	if (_inner_error_ != NULL) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp27_ = originalKeyFileData;
	_tmp28_ = self->priv->keyFile;
	_tmp29_ = g_key_file_to_data (_tmp28_, NULL, NULL);
	_tmp30_ = _tmp29_;
	_tmp31_ = g_strcmp0 (_tmp27_, _tmp30_) != 0;
	_g_free0 (_tmp30_);
	result = _tmp31_;
	_g_free0 (originalKeyFileData);
	return result;
}


/**
 * Write settings file.
 */
static void user_settings_manager_writeKeyFile (UserSettingsManager* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		const gchar* _tmp0_;
		GKeyFile* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		_tmp0_ = self->priv->psNotesConfPath;
		_tmp1_ = self->priv->keyFile;
		_tmp2_ = g_key_file_to_data (_tmp1_, NULL, NULL);
		_tmp3_ = _tmp2_;
		g_file_set_contents (_tmp0_, _tmp3_, (gssize) (-1), &_inner_error_);
		_g_free0 (_tmp3_);
		if (_inner_error_ != NULL) {
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "Error writing keyFile: %s\n", _tmp6_);
		_g_error_free0 (e);
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void user_settings_manager_setNotesDir (UserSettingsManager* self, const gchar* path) {
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = path;
	g_key_file_set_string (_tmp0_, USER_SETTINGS_MANAGER_notesDirGroup, USER_SETTINGS_MANAGER_notesDirKey, _tmp1_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val) {
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = key;
	_tmp2_ = val;
	g_key_file_set_integer (_tmp0_, USER_SETTINGS_MANAGER_notesDirGroup, _tmp1_, _tmp2_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_addNotebook (UserSettingsManager* self, const gchar* name, const gchar* path) {
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = name;
	_tmp2_ = path;
	g_key_file_set_string (_tmp0_, USER_SETTINGS_MANAGER_notebooksGroup, _tmp1_, _tmp2_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_removeNotebook (UserSettingsManager* self, const gchar* name) {
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = name;
	g_key_file_remove_key (_tmp0_, USER_SETTINGS_MANAGER_notebooksGroup, _tmp1_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	user_settings_manager_writeKeyFile (self);
}


GeeArrayList* user_settings_manager_getNotebookList (UserSettingsManager* self) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* list;
	GKeyFile* _tmp1_;
	gsize _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint __tmp4__size_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	list = _tmp0_;
	_tmp1_ = self->priv->keyFile;
	_tmp3_ = g_key_file_get_keys (_tmp1_, USER_SETTINGS_MANAGER_notebooksGroup, &_tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	__tmp4__size_ = _tmp4__length1;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp4_;
		s_collection_length1 = _tmp4__length1;
		for (s_it = 0; s_it < _tmp4__length1; s_it = s_it + 1) {
			gchar* _tmp5_;
			gchar* s = NULL;
			_tmp5_ = g_strdup (s_collection[s_it]);
			s = _tmp5_;
			{
				const gchar* _tmp6_;
				_tmp6_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) list, _tmp6_);
				_g_free0 (s);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = list;
	return result;
}


static void user_settings_manager_class_init (UserSettingsManagerClass * klass) {
	user_settings_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UserSettingsManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = user_settings_manager_finalize;
}


static void user_settings_manager_instance_init (UserSettingsManager * self) {
	self->priv = USER_SETTINGS_MANAGER_GET_PRIVATE (self);
}


static void user_settings_manager_finalize (GObject* obj) {
	UserSettingsManager * self;
	self = USER_SETTINGS_MANAGER (obj);
	_g_key_file_free0 (self->priv->keyFile);
	_g_free0 (self->priv->psNotesConfPath);
	G_OBJECT_CLASS (user_settings_manager_parent_class)->finalize (obj);
}


GType user_settings_manager_get_type (void) {
	static volatile gsize user_settings_manager_type_id__volatile = 0;
	if (g_once_init_enter (&user_settings_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserSettingsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_settings_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserSettingsManager), 0, (GInstanceInitFunc) user_settings_manager_instance_init, NULL };
		GType user_settings_manager_type_id;
		user_settings_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "UserSettingsManager", &g_define_type_info, 0);
		g_once_init_leave (&user_settings_manager_type_id__volatile, user_settings_manager_type_id);
	}
	return user_settings_manager_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



